/*-
 * Copyright (c) 2008 Andrey V. Surkov <nsand@sura.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	 $Id: db.c,v 0.52 2008/05/23 07:54:36 nsand Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>	//  u_long
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <sys/stat.h>
#include "db.h"
#include "skyfish.h"

/*
*     ,  dst=0    
*/
u_short
FindEmptyPlaceDB(void) {
    int i;
    for (i = 0; i < MAXTHREADS; i++)
	if (db[i].dst == 0){
	    numpks=i;
	    return 0;
	}
    return 1;
}

/*
*      (HTTP 200,206)
*/
int 
AddPKSDB(u_char * packet)
{
    struct ip *ip 	= (struct ip *) (packet); 
    struct tcphdr *tcp	= (struct tcphdr *)(packet + IP_H);
    u_char *data_tcp	= (u_char *) (packet + IP_H + (tcp->th_off<<2));

    if (FindEmptyPlaceDB() == 1) return 1;
    if ( FileLength(data_tcp) < MIN_FILE_SIZE ) return 1;
    ClearPKS(numpks);
    db[numpks].start_count = htonl(tcp->th_seq);
    DelHeadHTTP(len_HTTP(data_tcp,ip->ip_len));
    db[numpks].dst = ip->ip_dst.s_addr;
    db[numpks].src = ip->ip_src.s_addr;
    db[numpks].port_d = tcp->th_dport;
    db[numpks].port_s = tcp->th_sport;
    db[numpks].ack = tcp->th_ack;
    db[numpks].lencur = 0;
    db[numpks].X = GetX(data_tcp);
    time(&db[numpks].atime);
    time(&db[numpks].ctime);
    db[numpks].len = FileLength(data_tcp);
    GetName(data_tcp);
    if (Filter() == 1) {ClearPKS(numpks);return 1;}
    u_char path[300];    
    if (db[numpks].refer == MAXTHREADS) {
	//        ,     INTERFILM  ,  &
	umask(0);
	sprintf(path,"%s/%s",PATH_TEMP,db[numpks].name);
	db[numpks].fd = open(path,O_RDWR | O_CREAT,00666);
	if (db[numpks].fd == -1) {
	    ClearPKS(numpks);
	    Logger("error open file fd\n");
	    Logger(path);
	    Logger("\n");
	    return 1;
	}
	
	sprintf(path,"%s/%s.fx",PATH_TEMP,db[numpks].name);
	db[numpks].fp = fopen(path,"w+");
	if (db[numpks].fp == NULL) {
	    close(db[numpks].fd);
	    Logger("error open file fp\n");
	    Logger(path);
	    Logger("\n");
	    ClearPKS(numpks);
	    return 1;
	}
	u_int64 fy=0,fx=db[numpks].len;
	fwrite(&fx,1,8,db[numpks].fp);
	fwrite(&fy,1,8,db[numpks].fp);
	db[numpks].numfx = 1;
    }
    countpks++;	
    if (db[numpks].refer == MAXTHREADS) openfiles += 2;
    return 0;
}



int 
GetName(u_char *data_tcp) {

    int i = 0;
    sprintf(db[numpks].findname,"%s",FindFileName(data_tcp));
    sprintf(db[numpks].type,"%s",GetContType(data_tcp));
    get_ETAG(data_tcp);			//   ETag:
	
    memset(db[numpks].name,0,250);
    if ( ( i = SearchOldNameDB()) == MAXTHREADS) {
	sprintf(db[numpks].name,"%08x_%08x_%0x_%0x_%x-%s.",
        db[numpks].src, db[numpks].dst,	db[numpks].port_s, db[numpks].port_d, db[numpks].ack,
	db[numpks].etag);
	if (get_HTTP(data_tcp) == 200) {
	    db[numpks].begin=200; 
	}
    } else {  // - -      ..       
//	    sprintf(db[numpks].name,"%s",db[i].name);
	    if (get_HTTP(data_tcp) == 200)  { 
		db[i].begin=200;
	    }
     }
     
    return 0;
}

/*
*              
*/
int 
SearchOldNameDB(void)  {

    int i;
    for (i=0;i<MAXTHREADS;i++)
	if ( db[i].refer == MAXTHREADS)
	if ( strcmp(db[i].etag,db[numpks].etag) == 0)
	if (db[i].dst == db[numpks].dst)
	if (db[i].src == db[numpks].src)	
	if (db[i].port_s == db[numpks].port_s)	
	if ( i != numpks )
	if ( db[i].len == db[numpks].len )
	if ( strcmp(db[i].findname,db[numpks].findname) == 0)  {
	    db[numpks].refer=i;
	    return i;
	}
db[numpks].refer=MAXTHREADS;
return MAXTHREADS;
}

/*
*     ,      1 -  
*/
int 
FindPKSDB(u_char *packet) {
    struct ip *ip 	= (struct ip *) (packet); 
    struct tcphdr *tcp	= (struct tcphdr *)(packet + IP_H);
    u_long i=0;
    for (i=0;i<MAXTHREADS;i++) {
	if (db[i].dst == ip->ip_dst.s_addr)
	if (db[i].src == ip->ip_src.s_addr)
	if (db[i].port_d == tcp->th_dport)
	if (db[i].port_s == tcp->th_sport)
	if (db[i].ack == tcp->th_ack) { 
	    numpks=i; 
	    return 0;
	}
    }
    return 1;
}


/*
*         Content-Range: X-Y/Z
*/
u_int64 
GetX(u_char *data_tcp) {

    u_int64 X=0;
    u_char * found_str=strstr(data_tcp,"Content-Range: bytes");
    if ( found_str!= NULL ) {
	sscanf(found_str+21,"%lu",&X);
	return X;
    }
return 0;
}


/*
*	     Cont-Range Cont-Length
*/
u_int64 
FileLength(u_char * data_tcp) {

    u_int64 filelength = 0;

    u_char * found_str = strstr(data_tcp,"Content-Range: bytes");
    if ( found_str != NULL ) {
	u_char *found_str2 = strstr(found_str + 21,"/");
	sscanf(found_str2 + 1,"%lu",&filelength);
	return filelength;
    }
    found_str = strstr(data_tcp,"Content-Length:");
    if ( found_str != NULL ) {
	if (sscanf(found_str+16,"%lu",&filelength) > 0) {
	    return filelength;
	} else { 
	Logger("not found Content-Length:\n");
	}
    }
return 0;
}

//      
/*int
CheckType(u_char *data_tcp,u_int64 filesize) {

    if (filesize < MIN_FILE_SIZE ) return 1;
return 0;
}
*/

void ClearPKS(u_long ref) {
    memset(&db[ref],0,PKS);
    db[ref].refer = MAXTHREADS;
}

int
Filter() {

    int i;
    for (i = 0; i < SORTBUFFER; i++)
	if ( strcmp(sortdb[i].type,db[numpks].type) == 0)
	    {
	    if (db[numpks].len < sortdb[i].min ||  db[numpks].len > sortdb[i].max) return 1;
	    }
return 0;
}
