/*-
 * Copyright (c) 2008 Andrey V. Surkov <nsand@sura.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	 $Id: file_sky.c,v 0.52 2008/05/23 07:54:36 nsand Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/ip_icmp.h>
#include <netinet/ip_var.h>
#include <netinet/tcp_var.h>
#include "skyfish.h"
#include "file_sky.h"

#include <termios.h>
#include <term.h>
#include <curses.h>

//  , -    
int
DelTree(u_long num) {

    u_long ref=0;
    u_long pr=0;    
    u_long i=0;
    if ( db[num].refer < MAXTHREADS ) ref=db[num].refer;
	else ref=num;

    if (db[ref].len > 200) pr = db[ref].lencur / (db[ref].len / 100.0);
    if (pr > NOCOMPLETE) {
    	close(db[ref].fd);
	fclose(db[ref].fp);	
	openfiles -= 2;
	ClearTMP();
	sprintf(tmp,"mv %s/%s %s",PATH_TEMP,db[ref].name,PATH_INCOMPLETE);
	system(tmp);
	ClearTMP();
	u_char src[300],dst[300];
	sprintf(src,"%s/%s",  PATH_INCOMPLETE, db[ref].name);
	sprintf(dst,"%s/%s%s",PATH_INCOMPLETE, db[ref].name, db[ref].type);
	rename(src,dst);
	sprintf(tmp,"rm %s/%s.fx",PATH_TEMP,db[ref].name);
	system(tmp);
    } else  {
	    DelFile(ref);
	    }
	
    writraf -= db[ref].lencur;
    ClearTree(ref);
/*    for (i = 0; i < MAXTHREADS; i++)
	if (db[i].refer == ref) {
	    ClearPKS(i);
	    countpks--;
	}
    ClearPKS(ref);*/
    countpks--;
return 0;
}


void
DelFile(u_long ref)
{
	close(db[ref].fd);
	fclose(db[ref].fp);	
	openfiles -=2;			    
	ClearTMP();
//	sprintf(tmp,"rm ./temp/%s.fx",db[ref].name);
	sprintf(tmp,"rm %s/%s.fx",PATH_TEMP,db[ref].name);
	system(tmp);
	ClearTMP();
//	sprintf(tmp,"rm ./temp/%s",db[ref].name);
	sprintf(tmp,"rm %s/%s",PATH_TEMP,db[ref].name);
	system(tmp);
}
//-------------------------------------  FileFull  -----------------------------
//   ok    db  200  206 
int 
FileFull(u_long num)
{
    u_long ref=0;
    u_long i;
    u_char ext [32];

    if ( db[num].refer < MAXTHREADS ) ref=db[num].refer;
	else ref=num;
    sprintf(tmp,"mv %s/%s %s",PATH_TEMP,db[ref].name,PATH_OK);

	memset(tmp,0,300);
	if (strstr(db[ref].findname,"noname") != NULL){
	sprintf(tmp,"mv %s/%s %s/%08x_%08x_%u_%u_%u.%s",PATH_TEMP,db[ref].name,PATH_OK,
    		db[ref].src, db[ref].dst,db[ref].port_s,db[ref].port_d,db[ref].ack,db[ref].type);
		} else {
	sprintf(tmp,"mv %s/%s %s/%08x_%u_%s.%s",PATH_TEMP,db[ref].name,PATH_OK,
    		db[ref].dst,db[ref].port_s,db[ref].findname,db[ref].type);
		}
	
        close(db[ref].fd);
        fclose(db[ref].fp);	
	openfiles -= 2;
	
	system(tmp);			    

	sprintf(tmp,"rm %s/%s.fx",PATH_TEMP,db[ref].name);
	system(tmp);

    ClearTree(ref);    
    countpks--;
return 0;
}


/*
*
*/
u_long 
GetRefer(void) {
    if ( db[numpks].refer < MAXTHREADS ) 
	return db[numpks].refer;
    else 
	return numpks;
}


int
WriteData(u_char *packet)
{
//       
    struct ip *ip 	= (struct ip *) (packet); 
    struct tcphdr *tcp	= (struct tcphdr *)(packet + IP_H);
    u_char *data_tcp	= (u_char *) (packet + IP_H + (tcp->th_off<<2));
    u_long x=0,y=0,fx=0,fy=0,d=0;
    int res=0;
    u_long count_data;
    int posik=0;
    u_long pos=0;
    u_long countold=0;
    time(&db[numpks].atime);
    u_long refer = GetRefer();
    u_long offset= db[numpks].offset;
    pos = ( htonl(tcp->th_seq) ) - db[numpks].start_count; 
    pos += db[numpks].X;

    if (db[numpks].offset > 0) { 
	db[numpks].start_count += offset;
	db[numpks].offset=0; 
    }
    
    count_data = ip->ip_len - (IP_H + (tcp->th_off<<2));
    count_data -= offset;
    if (count_data == 0 ) return 0;
    x = pos;
    y = x + count_data;
    if (y > 0) y--;		//    
    fseek(db[refer].fp,0,SEEK_SET);						//   
    fread(mas,(db[refer].numfx + 1) * 4,1,db[refer].fp);		//   

for (posik=0;posik < db[refer].numfx;posik +=2) {
    
    fx = mas[posik];
    fy = mas[posik + 1];

    if (fx < fy) { 				//    
	res = GetPerek(x,y,fx,fy);
	d=0;
	switch (res) {
	case P_NO:	break;
	case P_IN:	return 0;		//      
			break;
	case P_LEFT: 	// !!!!!!!!!!		    
			d = fy - x + 1;
			count_data -= d;	//   
			if (count_data == 0) posik = db[refer].numfx;
			pos += d;
			x += d;
			offset += d;
			break;

	case P_RIGHT:	
			d = y - fx + 1;
			count_data -= d;
			if (count_data == 0) posik = db[refer].numfx;
			y -= d;
			break;
			
	case P_ALL:	
			d = fy - fx + 1;
			mas[posik] = db[refer].len; //fx;
			mas[posik + 1] = 0;//fy;
			db[refer].lencur -=  d;
			break;
		}    // end switch (res)
	    } // fx < fy
    } //while



    u_long i=0, z=0;    
    fseek(db[refer].fp,0,SEEK_SET);
    if (count_data > 0){
	    for (i = 0; i < db[refer].numfx; i += 2)	{ // numfx   [0-12][13-20]
		if (mas[i] < mas[i + 1]) {
		    if      ( (x - 1) == mas[i + 1] )	{mas[i + 1] = y; z=1; i = db[refer].numfx;}
		    else if ( (y + 1) == mas[i] )	{mas[i] = x; z=1; i = db[refer].numfx;}
		}
	    }
	    
	    if (z == 0){
		mas[posik] = x;
		mas[posik + 1] = y;
		db[refer].numfx += 2;
	    }

	    db[refer].lencur += count_data;
	    fwrite(mas, ((db[refer].numfx + 1 )  * 4),1,db[refer].fp);
    } else {
	    return 0;
    	    }
	

    if (db[refer].fd != -1){
    lseek(db[refer].fd,pos,SEEK_SET);
    write(db[refer].fd,(data_tcp + offset),count_data);
    time(&db[refer].atime);
    writraf += count_data;
    if (pos == 0) { 
	ChangeType(refer);
	if (Filter() == 1) { 
	    db[refer].ctime = 1; 
	    db[refer].begin = 0;
	    CheckTime();
	}
    }
	//}	
	//    .   4  ))
    }
    
return 0;
}


int CheckTime()
{
    time_t curtime;
    time(&curtime);
    u_long i = 0;
    for (i = 0; i < MAXTHREADS; i++)
    {
	if ( db[i].dst > 0 && (db[i].refer == MAXTHREADS)) {
	    if (db[i].lencur == db[i].len) 	FileFull(i);
	    else if (db[i].lencur > db[i].len) 	DelHEAD(i);
	    else if ( ( (curtime - db[i].atime) >= TIME_END_FILE) || 
		( db[i].begin == 0 && (curtime - db[i].ctime) >= TIME_LIVE_BEGIN )) {
		    DelTree(i);
		    ClearPKS(i);
		    }
	    else if (  (curtime - db[i].ctime) >= 10 && strcmp(db[i].type,"none") == 0 ) 
	    {    DelTree(i);	    ClearPKS(i);		} 
	}
	if ( (db[i].dst > 0) && (db[i].refer < MAXTHREADS) &&((curtime - db[i].atime) >= TIME_LIVE_THREAD)) {
	    countpks--;
	    ClearPKS(i);
	}
    }
return 0;
}


/*
*             
*/
int
GetPerek(u_int64 x, u_int64 y, u_int64 fx, u_int64 fy) {

	 if (x  > fx && x <= fy && y >  fx && y > fy)	return P_LEFT;
    else if (x  < fx && x <  fy && y >= fx && y < fy) 	return P_RIGHT;
    else if (x  < fy && x >= fx && y >  fx && y <= fy) 	return P_IN;
    else if (fx >= x && fy <= y) 			return P_ALL;
    else						return P_NO;
}


/*
*    
*/
void 
Logger(u_char *data) {
    fwrite(data,strlen(data),1,flog);
    fflush(flog);
}

void 
DelHEAD(u_long ref){
	u_long type=0;
	Logger("DelHead\n");
	Logger(db[ref].name);
	lseek(db[ref].fd,0,SEEK_SET);
	 read(db[ref].fd,&type,4);
	if (type == HEAD_HTTP) {
	    u_long p=0,n=0;
	    lseek(db[ref].fd,0,SEEK_SET);
	    n = read(db[ref].fd,tmp,LENTMP);
	    int lenhttp = len_HTTP(tmp,n);
	    if (lenhttp > 0)
		for (p=lenhttp; p <= db[ref].len; p +=LENTMP) {
		    lseek(db[ref].fd,p,SEEK_SET);
		    n = read(db[ref].fd,tmp,LENTMP);
		    lseek(db[ref].fd,p - lenhttp,SEEK_SET);
		    write(db[ref].fd,tmp,n);
		}
	    db[ref].len -= lenhttp;
    	}
	//      truncate
	truncate(db[ref].name,db[ref].len);
	FileFull(ref);
}


/*
*    4 ..      none .
*        Filter
*/
int 
ChangeType(u_long refer) {

    u_long bkod = 0;
    lseek(db[refer].fd, 0, SEEK_SET);
    read (db[refer].fd, &bkod, 4);
    
    if ( strstr(db[refer].type, "none") != NULL) {
	 memset(db[refer].type, 0, 32);
	switch (bkod) {
	    case BKOD_RAR:	strcpy(db[refer].type,"rar");	break;
    	    case BKOD_7Z: 	strcpy(db[refer].type,"7z");	break;
	    case BKOD_EXE: 	strcpy(db[refer].type,"exe");	break;
	    case BKOD_EXE2: 	strcpy(db[refer].type,"exe");	break;
	    case 0xE011CFD0: 	strcpy(db[refer].type,"msi");	break;
	    case BKOD_FLV: 	strcpy(db[refer].type,"flv");	break;
	    case BKOD_MPG: 	strcpy(db[refer].type,"mpg");	break;
	    case BKOD_CAB: 	strcpy(db[refer].type,"cab");	break;
	    case BKOD_CAB2:	strcpy(db[refer].type,"cab");	break;
	    case BKOD_ZIP: 	strcpy(db[refer].type,"zip");	break;
	    case BKOD_AVI:	strcpy(db[refer].type,"avi");	break;
	    case 0x38464947: 	strcpy(db[refer].type,"gif");	break;
	    case BKOD_JPG: 	strcpy(db[refer].type,"jpeg");	break;
	    case BKOD_MP3: 	strcpy(db[refer].type,"mp3");	break;
	    case BKOD_WMV: 	strcpy(db[refer].type,"wmv");	break;
	    case BKOD_PDF: 	strcpy(db[refer].type,"pdf");	break;
	    case BKOD_NUP: 	strcpy(db[refer].type,"nup");	break;
	    case BKOD_JPEG: 	strcpy(db[refer].type,"jpeg");	break;
	    case BKOD_OGG: 	strcpy(db[refer].type,"avi");	break;
	    case BKOD_CHM: 	strcpy(db[refer].type,"chm");	break;
	    case BKOD_RMF: 	strcpy(db[refer].type,"rm");	break;
	    case BKOD_PNG: 	strcpy(db[refer].type,"png");	break;
	    case BKOD_KAV: 	strcpy(db[refer].type,"kav");	break;
	    case BKOD_MP32:	strcpy(db[refer].type,"mp3");	break;
	    case BKOD_MP33:	strcpy(db[refer].type,"mp3");	break;	
	    case BKOD_HTML:	strcpy(db[refer].type,"html");	break;	
	    case BKOD_3GP:	strcpy(db[refer].type,"3gp");	break;		
	    case BKOD_DJV:	strcpy(db[refer].type,"djvu");	break;		
	    case BKOD_GOOG:	strcpy(db[refer].type,"goog");	break;		
	    case BKOD_SWF:	strcpy(db[refer].type,"swf");	break;			    
	    case BKOD_BMP:	strcpy(db[refer].type,"bmp");	break;			    
	    case BKOD_DRWEB:	strcpy(db[refer].type,"dweb");	break;
	    case BKOD_HTM2:	strcpy(db[refer].type,"html");	break;
	    default:		strcpy(db[refer].type,"non");	return 0;break;
	}
    }
    
return 1;
}

/*
*	       ref,    ref
*/
void
ClearTree(u_long ref) {

    u_long i;
    for (i = 0; i < MAXTHREADS; i++)
	if (db[i].refer == ref) {
	    ClearPKS(i);
	    countpks--;
	}
    ClearPKS(ref);
}
