/*-
 * Copyright (c) 2008 Andrey V. Surkov <nsand@sura.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	 $Id: interface.c,v 0.58 2008/05/23 07:54:36 nsand Exp $
 */
 
#include <termios.h>
#include <term.h>
#include <curses.h>
#include <unistd.h>
#include <string.h>

#include <errno.h>
#include <sys/ioctl.h>

#include <signal.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <sys/event.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <netinet/tcp_var.h>
#include "skyfish.h"

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <sys/event.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <netinet/tcp_var.h>
#include "interface.h"

#define SETCOLOR(a) attrset(COLOR_PAIR(a))
void
show_table(void) {

	double traf; 
	u_char nullstring [320];
	u_char tmp2 [300];
	int i;
	SETCOLOR(4);
	move(5, 0);			hline(' ',H_LINE);
	move(5, 0);			printw("|#N |          Filename");
	move(5,57 + H_LINE - 80); 	printw("|type | Lenght|Current|");
	SETCOLOR(1);			printw(" ");
	SETCOLOR(3);
	int num = 1;
	move(5 + num, 0);	
	memset(tmp,0,1024);
	if (db[V_CURSOR].refer != MAXTHREADS || db[V_CURSOR].dst == 0)
	    DecreaseCursor();
	if (db[V_CURSOR].refer != MAXTHREADS || db[V_CURSOR].dst == 0)	    
	    IncreaseCursor();
    for (i=0; i < MAXTHREADS && num < V_LINE;i++) {
	if (db[i].dst > 0 && db[i].refer == MAXTHREADS && db[i].begin == 200)  {
	    ClearTMP();
	    memset(tmp2,0,300);
	    strncpy(tmp2,db[i].name,H_LINE - 28);
	    sprintf(tmp,"|%3d|",num);
	    strncat(tmp,tmp2,H_LINE - 28);
	    memset(tmp2,32,300);
	    strncat(tmp,tmp2,H_LINE - 23 - strlen(tmp));
	    memset(tmp2,0,300);
	    sprintf(tmp2,"|%-5s",db[i].type);
	    strncat(tmp,tmp2,strlen(tmp2));
	    memset(tmp2,0,300);
	    traf=db[i].len;
	    if (traf > GB) 		sprintf(tmp2,"|%6.2fG|",traf/GBYTE);	
	    else if (traf > MB) 	sprintf(tmp2,"|%6.2fM|",traf/MBYTE);
	    else	 		sprintf(tmp2,"|%6.2fK|",traf/KBYTE);
	    strcat(tmp,tmp2);
	    memset(tmp2,0,300);
	    traf=db[i].lencur;
	    if (traf > GB) 		sprintf(tmp2,"%6.2fG",traf/GBYTE);	
	    else if (traf > MB) 	sprintf(tmp2,"%6.2fM",traf/MBYTE);
	    else 			sprintf(tmp2,"%6.2fK",traf/KBYTE);
	    strcat(tmp,tmp2);		
	    sprintf(tmp2,"|");
	    strcat(tmp,tmp2);		
	    u_long pr = (H_LINE / 100.0) * db[i].lencur / (db[i].len / 100.0);
	    memset(nullstring,0,320);
	    strncat(nullstring,tmp,pr);
    if (V_CURSOR != i)	SETCOLOR(7);	else	SETCOLOR(5);
	    printw("%s",nullstring);
	    memset(nullstring,0,320);
	    strncat(nullstring,tmp + pr,H_LINE);
    if (V_CURSOR != i)	SETCOLOR(3);	else	SETCOLOR(8);
	    printw("%s",nullstring);
	    SETCOLOR(1);printw(" ");
    if (V_CURSOR == i && DEL_FILE == 1 ) {db[i].ctime = 1; db[i].begin = 0;DEL_FILE=0;}			
	    num++;
	    move(5 + num,0);
    }
 }
    SETCOLOR(1);
    for (i = 5 + num; i <= V_LINE + 6; i++)
    { move(i, 0);			hline(' ',H_LINE + 1);}

//    SETCOLOR(1);
    move(5 + V_LINE,0);
    hline(ACS_HLINE,H_LINE);
    refresh();	    
    KEYPRESS = 0;
}

void
init_scr(void) {

    initscr();
    if(!has_colors()) {
	endwin();
	exit(1);
    }
    if(start_color() != OK) {
	endwin();
	exit(1);
    }
    init_pair(1, COLOR_WHITE, COLOR_BLACK);
    init_pair(2, COLOR_WHITE, COLOR_BLUE);
    init_pair(3, COLOR_WHITE, COLOR_BLACK);
    init_pair(4, COLOR_BLACK, COLOR_WHITE);
    init_pair(5, COLOR_BLACK, COLOR_YELLOW);
    init_pair(6, COLOR_WHITE, COLOR_RED);
    init_pair(7, COLOR_WHITE, COLOR_BLUE);
    init_pair(8, COLOR_BLACK, COLOR_WHITE);
clear();
}

void
show_title(void) {

	double traf; 
	SETCOLOR(2);
	move(0, 0);			hline(ACS_HLINE,H_LINE);
	move(1, 0);			hline(' ',H_LINE); 
	move(1, H_LINE / 2 - 7);	printw("SkyFish %s",VERSION);
	move(2, 0);			hline(ACS_HLINE,H_LINE);
	SETCOLOR(1);
	move(4, 0);			hline(' ',H_LINE); 
	move(3, 0);			hline(' ',H_LINE);
	if (speed < 1024) SETCOLOR(6);
	u_long srate = speed;
	printw("Symbol rate:");
	     if (srate > GB) printw("%6.2f[Gb/s]",srate/GBYTE);	
	else if (srate > MB) printw("%6.2f[Mb/s]",srate/MBYTE);
			   else printw("%6.2f[Kb/s]",srate/KBYTE);
	SETCOLOR(1);	
	printw(" IN:");
	traf=alltraf;
	     if (traf > TB) printw("%6.2f[Tb]",traf/TBYTE);
	else if (traf > GB) printw("%6.2f[Gb]",traf/GBYTE);	
	else if (traf > MB) printw("%6.2f[Mb]",traf/MBYTE);
			  else printw("%6.2f[Kb]",traf/KBYTE);
	printw(" Write:");
	traf=writraf;
	     if (traf > TB) printw("%6.2f[Tb]",traf/TBYTE);
	else if (traf > GB) printw("%6.2f[Gb]",traf/GBYTE);	
	else if (traf > MB) printw("%6.2f[Mb]",traf/MBYTE);
			  else printw("%6.2f[Kb]",traf/KBYTE);
	
	move(3,61 + H_LINE - 80);	
	printw("  press 'Q' to exit"); 
	SETCOLOR(1);	printw(" ");

	move(4,0);	
	printw("CountPKS = %u",countpks);
	move(4,15);	printw("OpenFile = %u",openfiles);
	move(4,30);	printw("Fragm = %u",frpks);	
	refresh();
}

void
init_kb(void)
{
	tcgetattr(0, &init_settings);
	new_settings = init_settings;
	new_settings.c_lflag &= ~ICANON;
	new_settings.c_lflag &= ~ECHO;
	new_settings.c_lflag &= ~ISIG;
	new_settings.c_cc[VMIN] = 1;
	new_settings.c_cc[VTIME] = 0;
	tcsetattr(0, TCSANOW, &new_settings);
}

void
CheckKey(int ch) {
    
    switch (ch) {
	case 'a': 	H_LINE--; if (H_LINE < 80) H_LINE=80;show_title();show_table();break;
	case 'd':	H_LINE++; if (H_LINE > 320) H_LINE=320;show_title();show_table();break;
	case 'w':	V_LINE--; if (V_LINE < 1) V_LINE=1;if (V_CURSOR > V_LINE) V_CURSOR=V_LINE;show_title();show_table();break;
	case 's':	V_LINE++; if (V_LINE > 300) V_LINE=300;show_title();show_table();break;
	case 'k':	DecreaseCursor(); KEYPRESS = 1;show_table();break;
	case 'j':	IncreaseCursor();	KEYPRESS = 1;show_table();break;
	case '-':	DEL_FILE = 1;show_table();CheckTime();show_table();break;
	case 'f':	ChFastScr();break;
	}
}

int
readch(void)
{
	char ch;
	
	if(peek_char != -1){
		ch = peek_char;
		peek_char = -1;
		return ch;
	}
	read(0, &ch, 1);
	return ch;
}

void 
DecreaseCursor(void) {
    int i;
    if (V_CURSOR > 0) 
	for (i = V_CURSOR - 1;i >= 0; i--)
	    if (db[i].refer == MAXTHREADS && db[i].dst > 0 && db[i].begin == 200) { 
		V_CURSOR = i; break;
	    }
}

void
IncreaseCursor(void) {
    int i;
    for (i = V_CURSOR + 1;i < MAXTHREADS; i++)
	if (db[i].refer == MAXTHREADS && db[i].dst > 0 && db[i].begin == 200) { 
	    V_CURSOR = i; break;
	}

}

int
hit_kb(void)
{
	char ch;
	int nread;

	if(peek_char != -1)
		return -1;
	
	new_settings.c_cc[VMIN] = 0;
	tcsetattr(0, TCSANOW, &new_settings);
	nread = read(0, &ch, 1);
	new_settings.c_cc[VMIN] = 1;
	tcsetattr(0, TCSANOW, &new_settings);
	
	if(nread == 1){
		peek_char = ch;
		return 1;
	}

	return 0;
}
