/*-
 * Copyright (c) 2008 Andrey V. Surkov <nsand@sura.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	 $Id: my_types.h,v 0.52 2008/05/23 07:54:36 nsand Exp $
 */

#include <net/ethernet.h>
 
#ifndef _SKYFISH_TYPE_
#define	_SKYFISH_TYPE_

typedef u_long	u_int64;

#define TBYTE 1099511627776.0
#define GBYTE 1073741824.0	
#define MBYTE 1048576.0
#define	KBYTE 1024.0

#define TB 1000000000000.0
#define GB 1000000000.0	
#define MB 1000000.0
#define	KB 1000.0
#define	LENTMP 1024
static char VERSION[] = "0.60";

#define HEAD_HTTP 0x54544848
#define TYPE_HTTP 0x50545448

int 	V_LINE;				//   
int 	H_LINE;				//  
int 	V_CURSOR;			//  
int 	OLD_CURSOR;			//  
int 	DEL_FILE;			//   
u_char	FAST_SCREEN;			//   
u_char 	KEYPRESS;
u_short	NOCOMPLETE;			//      incomplete
u_long 	allpks;
u_long	TIME_LIVE_THREAD;
u_long	TIME_LIVE_BEGIN;			//       HTTP 200
u_long	TIME_END_FILE;			//        ..  END_THREAD
u_long 	MAXTHREADS;			//  - 
u_long 	SORTBUFFER;			//  - 
u_int64 MIN_FILE_SIZE;
FILE 	*flog;
u_char 	PATH_OK[300];
u_char 	PATH_TEMP[300];
u_char 	PATH_INCOMPLETE[300];
u_char 	PATH_LOG[300];
/*
struct  {

    struct eh
    struct ip
    data

}
*/
u_char tmp[LENTMP];
#define ClearTMP() { memset(tmp,0,LENTMP); }

#define BKOD_RAR 0x21726152
#define BKOD_EXE 0x905a4d
#define BKOD_EXE2 0x00505A4D
#define BKOD_JPG 0xe0ffd8ff
#define BKOD_MP3 0x3334449
#define BKOD_FLV 0x1564c46
#define BKOD_CAB 0x4643404d
#define BKOD_CAB2 0x4643534d
#define BKOD_ZIP 0x4034b50
#define BKOD_AVI 0x46464952
#define BKOD_MPG 0xba01
#define BKOD_WMV 0x75b22630
#define BKOD_7Z 0xafbc7a37
#define BKOD_PDF 0x46445025
#define BKOD_NUP 0x30d90
#define BKOD_JPEG 0xe1ffd8ff
#define BKOD_OGG 0x5367674f
#define BKOD_CHM 0x46535449
#define BKOD_RMF 0x464d522e
#define BKOD_XML 0x464d522e
#define BKOD_PNG 0x474e5089
#define BKOD_KAV 0x6b437055
#define BKOD_MP32 0x4b0fbff
#define BKOD_MP33 0x6490fbff
#define BKOD_HTML 0x0a0a0a0a
#define BKOD_3GP 0x14000000
#define BKOD_DJV 0x54265441	//   AT&T
#define BKOD_GOOG 0x6f6f675b
#define BKOD_SWF 0x07535743
#define BKOD_BMP 0xd2364d42
#define BKOD_DRWEB 0x572e7244
#define BKOD_HTM2 0x6d74683c


#define TEXT_HTML "Content-Type: text/html"
#define TEXT_JPEG "Content-Type: image/jpeg"
#define TEXT_GIF  "Content-Type: image/gif"
#define TEXT_JSP  "Content-Type: application/x-javascript"
#define TEXT_JSP2 "Content-Type: text/javascript"
#define TEXT_WMV  "Content-Type: video/x-ms-wmv"
#define TEXT_CSS  "Content-Type: text/css"
#define TEXT_DOC  "Content-Type: application/msword"
#define TEXT_PDF  "Content-Type: application/pdf"
#define TEXT_FLS  "Content-Type: application/x-shockwave-flash"
#define TEXT_PNG  "Content-Type: image/png"
#define TEXT_XML  "Content-Type: text/xml"
#define TEXT_DEB  "Content-Type: application/x-debian-package"
#define TEXT_ZHTM "Content-Type: application/x-zip"
#define TEXT_FLV  "Content-Type: video/x-flv"
#define TEXT_ISO  "Content-Type: application/x-iso9660"
#define TEXT_FLV2 "Content-Type: video/flv"
#define TEXT_MPEG "Content-Type: video/mpeg"
#define TEXT_MP3  "Content-Type: audio/mpeg"
#define TEXT_JSP3 "Content-Type: application/javascript"
#define TEXT_MOV  "Content-Type: video/quicktime"



struct pks {
    u_long dst;				// 32 bit IP
    u_long src;				// 32 bit IP
    u_short port_d;			// 16 bit TCP
    u_short port_s;			// 16 bit TCP
    u_long ack;				// 32 bit TCP
    u_long start_count;			// 32 bit TCP = ack
    u_long refer;			//       
    u_int64 X;				// 64 bit length file ii Content-Range
    u_int64 len;			// 64 bit length file
    u_int64 lencur;			// 64 bit summ of bytes    
    u_long numfx;
    time_t atime;
    time_t ctime;
    u_char begin;
    u_long offset;			// offset HEAD HTTP 
    u_char name[250];
    u_char findname[250];		//    
    u_char type[32];
    u_char etag[32];
    u_long typef;			//      
    int fd;
    FILE *fp;
};

#define PKS 	sizeof(struct pks)

    u_long mas[ 10000 ];  //   
    u_char minname[350];
    u_char filename[250];
    u_long numpks;
    u_long speed;
    u_long openfiles;
    u_long countpks;
    u_long frpks;
    long long alltraf; 
    long long writraf;     
    struct pks *db;
    struct filt *sortdb;
    static struct termios init_settings, new_settings;
    static int peek_char = -1;
#define IP_H    sizeof(struct ip)
#define TCP_H   sizeof(struct tcphdr)
	    //       ..  .         ..
#define TIME_CHECK 1
#define ETHSIZE	sizeof(struct ether_header)
#define LENMINNAME 57


struct fragment {
    struct in_addr ip_src;
    struct in_addr ip_dst;
    u_short	ip_p;
    u_short	ip_id;
    u_char*	data[1500];
    u_char* 	rcvbt[190];
    struct ip*	header;
    u_short	tdl;
    u_long	timer;
};

struct filt {
    u_char type[32];
    long long min;
    long long max;
};

#endif 
