/*-
 * Copyright (c) 2008 Andrey V. Surkov <nsand@sura.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	 $Id: parse_http.c,v 0.52 2008/05/23 07:54:36 nsand Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <netinet/tcp_var.h>
#include "parse_http.h"
#include "skyfish.h"

#include <termios.h>
#include <term.h>
#include <curses.h>


//-------------------------------------  get_HTTP  -----------------------------
int 
get_HTTP(u_char *str) {
    u_long res=0;
    u_long *http = (u_long *)(str);
    if (*http == TYPE_HTTP) {
    	sscanf( (str + 9),"%lu",&res);	//     9
    } else res = 0;
 return res;
}

//-----------------------------------  FindFileName  -------------------------
u_char *
FindFileName(u_char * str_data) {

    ClearTMP();
    u_char *ptr = (u_char *)tmp;
    u_char *pos = strstr(str_data,"filename=");
    if ( pos != NULL ) {
	pos += 9;
	int n;
	for (n = 0; n < 64; n++) {
    	    if ( *pos == '"' )  {pos++;continue;}
	    if ( *pos == ' ' )  {pos++;continue;}
	    if ( *pos == ')' )  {pos++;continue;}	
	    if ( *pos == '(' )  {pos++;continue;}	
	    if ( *pos == '/' )  {pos++;continue;}		
	    if ( *pos == '\\' ) {pos++;continue;}		
	    if ( *pos == 13 ||  *pos == '&' || *pos == '\0' || *pos == ';' || *pos == '?') {n=64;break;}
		*ptr++ = *pos++;
	}
	return tmp;
    }
    strncpy(tmp,"noname",7);
return tmp;    
}

//------------------------------------  len_HTTP  ------------------------------
int 
len_HTTP(u_char *data_tcp,u_short len) {  

    u_short i = 0;
    for (i = 0; i < (len - 4); i++) {	
	if ( *(data_tcp + i)     == 13 && *(data_tcp + i + 1) == 10)
	if ( *(data_tcp + i + 2) == 13 && *(data_tcp + i + 3) == 10) { 
	    return (i + 4); 
	}
    }
return 0;
}


void 
DelHeadHTTP(u_long lenhttp) {
    
    db[numpks].offset = lenhttp;
}

void 
DelHeadHTTPForce(u_long lenhttp) {
    
    if (lenhttp > 0) {
	db[numpks].start_count += lenhttp;
    }
}

u_char *
GetContType(u_char *data_tcp)  {

    if (strstr(data_tcp,TEXT_JPEG) != NULL) return "jpeg";
    if (strstr(data_tcp,TEXT_GIF)  != NULL) return "gif";
    if (strstr(data_tcp,TEXT_JSP)  != NULL) return "jsp";
    if (strstr(data_tcp,TEXT_JSP2) != NULL) return "jsp";
    if (strstr(data_tcp,TEXT_JSP3) != NULL) return "jsp";
    if (strstr(data_tcp,TEXT_WMV)  != NULL) return "wmv";
    if (strstr(data_tcp,TEXT_CSS)  != NULL) return "css";
    if (strstr(data_tcp,TEXT_DOC)  != NULL) return "doc";
    if (strstr(data_tcp,TEXT_PDF)  != NULL) return "pdf";
    if (strstr(data_tcp,TEXT_FLS)  != NULL) return "swf";
    if (strstr(data_tcp,TEXT_PNG)  != NULL) return "png";
    if (strstr(data_tcp,TEXT_XML)  != NULL) return "xml";
    if (strstr(data_tcp,TEXT_DEB)  != NULL) return "deb";
    if (strstr(data_tcp,TEXT_ZHTM) != NULL) return "html";
    if (strstr(data_tcp,TEXT_FLV)  != NULL) return "flv";
    if (strstr(data_tcp,TEXT_ISO)  != NULL) return "iso";
    if (strstr(data_tcp,TEXT_FLV2) != NULL) return "flv";
    if (strstr(data_tcp,TEXT_MPEG) != NULL) return "mpeg";
    if (strstr(data_tcp,TEXT_MP3)  != NULL) return "mp3";
    if (strstr(data_tcp,TEXT_JSP)  != NULL) return "jsp";
    if (strstr(data_tcp,TEXT_MOV)  != NULL) return "mov";
    return "none";
    //      AUDIO IMAGE VIDEO  ..
}


//------------------------------------  parse_TCP  -----------------------------
int 
parse_TCP(u_char *packet) {
//    struct tcphdr *tcp	= (struct tcphdr *)(packet + IP_H + ETHSIZE);
    struct ip *ip  	= (struct ip *) (packet + ETHSIZE);
    struct tcphdr *tcp	= (struct tcphdr *)(packet +  (ip->ip_hl<<2) + ETHSIZE);
    u_char *data_tcp	= (u_char *) (packet + IP_H + (tcp->th_off<<2) + ETHSIZE);
    u_char *data 	= (u_char *) (packet + ETHSIZE);
    
    int type_http = get_HTTP(data_tcp);
    if (type_http < 200) {
	if (FindPKSDB(data) == 0)    	WriteData(data);
    } 
    else if (type_http >= 200 && type_http < 300) {
    	    if (AddPKSDB(data) == 0)	WriteData(data);
	 }
return 0;
}


//      sprintf
int
get_ETAG(u_char * str_data) {

    int n = 0;
    ClearTMP();
    memset(db[numpks].etag, 0 ,32);
    u_char *ptr = tmp;
    u_char *pos = strstr(str_data,"ETag:");
    if ( pos != NULL ) {
	pos += 5;			//  ETag:
	for (n=0;n<31;	n++) {
	    if ( *pos == '"' ) {pos++;continue;}
	    if ( *pos == ' ' ) {pos++;continue;}
	    if ( *pos == 13 ||  *pos == '&' || *pos == '\0' || *pos == ';') {n=64;break;}
	    *ptr++ = *pos++;
	}
	sprintf(db[numpks].etag,"%s",tmp);
	return 0;
    }
    sprintf(db[numpks].etag,"%s","etag");	
    return 1;    
};
