/*-
 * Copyright (c) 2008 Andrey V. Surkov <nsand@sura.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	 $Id: skyfish.c,v 0.52 2008/05/23 07:54:36 nsand Exp $
 */
#include <termios.h>
#include <term.h>
#include <curses.h>
#include <unistd.h>
#include <string.h>

#include <errno.h>
#include <sys/ioctl.h>

#include <signal.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <sys/event.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <netinet/tcp_var.h>
#include "skyfish.h"

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <sys/event.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <netinet/tcp_var.h>
#include "skyfish.h"

#ifndef NTOHS
#define NTOHS(a) (a) = ntohs((a))
#endif

    u_char *d;
int
main(int argc, char **argv)
{
    if (initialize() != 0) exit(1);
    int fd, kq, n=0;
    struct timespec ts = {2, 0};    /*  0      */

    d = malloc(0xffff + ETHSIZE);
	if (d == NULL) { printf("malloc d error\n");exit(1);}
	db = (struct pks *)calloc(MAXTHREADS,PKS);
	if (db == NULL) { printf("malloc db error\n");exit(1);}
	u_long in=0;
	for (in=0;in<MAXTHREADS;in++)
	    db[in].refer=MAXTHREADS;
    fd = open("/dev/skyfish", O_RDONLY, 0);
    if (fd == -1) {
	printf("Can't open /dev/skyfish \n");
	return -1;
	}
	
    if (CheckPath() == 1) exit(1);
    kq = kqueue();
    if (kq == -1)
	perror("kqueue");
	      
    struct kevent change;
    struct kevent event;    
    init_scr();
    show_title();		
    EV_SET(&change, fd, EVFILT_READ, EV_ADD | EV_ENABLE, 0, 0, isok());
    int i=0;		
    time_t curt = 0, oldt=0;
    
//    struct itimerval itv;
//    itv.it_value.tv_sec = 1;
//    itv.it_value.tv_usec = 0;
//    itv.it_interval.tv_sec = 1;
//    itv.it_interval.tv_usec = 0;
//    signal(SIGPROF, &timer_refresh);
//    setitimer(ITIMER_PROF, &itv, NULL);
    Logger("Start cycle\n");
	int ch;    
//	int i=0;
init_kb();
        int isevent = 0;
while(ch != 'Q')
{
        isevent = kevent(kq, &change, 1, &event, 1, &ts);
	ch = 0;
	if (FAST_SCREEN) show_table();
	if (hit_kb())  {
		ch = readch();
		CheckKey(ch);
	}    
	
	time(&curt);
	if ( (curt - oldt) >= TIME_CHECK) { 
		oldt = curt; 
		show_title();
		if ( !FAST_SCREEN ) show_table();
		CheckTime();
		speed=0;
	}
	if ( isevent > 0 ) {
	    allpks += event.data;
	    for (i = 0; i < event.data;i++)  {
		memset(d,0,0xffff + ETHSIZE);
	        if (read( fd, d, 0xffff + ETHSIZE ) > 0) {
			handler(d);
			} else {
			;
			}
		}
    }

}

    //      
    close_kb();
    close(kq);	
    close(fd);	
    free(d);
    free(db);
    free(sortdb);
    CloseProg();
    return 0;	
}


//--------------------------------------  isok    ------------------------------
int 
isok()
{
	//printf("Start kevent!\n");
	return 0;
}


int 
handler(u_char * packet) {

    int frag=0;
    u_char* sobranIP;
    struct ip *ip  = (struct ip *) (packet + ETHSIZE);
    u_long len_tcp = ( ntohs(ip->ip_len) - (ip->ip_hl<<2));		
    
    if (len_tcp == 0) return 0;
/*
    u_short chk_sum3 = in_cksum3((u_short *)(packet + ETHSIZE),  ip->ip_hl<<2, ip->ip_sum);
    if (chk_sum3 != ip->ip_sum)  { 
//	Logger("chk_sum3 error!\n");
	ClearTMP();
	sprintf(tmp,"id = %-10u    off = %-10u   adr= %08x   sum\n",ntohs(ip->ip_id),ntohs(ip->ip_off),ip->ip_dst.s_addr);
	Logger(tmp);
//	return 0;
    }
*/    
    u_long lenip = ntohs(ip->ip_len);

    speed   += lenip;
    alltraf += lenip;
    if (ip->ip_p != IPPROTO_TCP) return 0;	
    
    if ( (ntohs(ip->ip_off) & IP_OFFMASK) != 0 || (ntohs(ip->ip_off) & IP_MF))
	 if ( (ntohs(ip->ip_off) & IP_DF) == 0 ) {
	 
    frag = 1;
	ClearTMP();
	sprintf(tmp,"id = %-10u    off = %-10u   adr= %08x\n fr",ntohs(ip->ip_id),ntohs(ip->ip_off),ip->ip_dst.s_addr);
	Logger(tmp);
	//      
	sobranIP = SborkaIP(packet);
	if ( sobranIP != NULL) packet = sobranIP;
	frpks++;
	}

    struct tcphdr *tcp	= (struct tcphdr *)(packet + (ip->ip_hl<<2) + ETHSIZE);	
    u_short chk_sum  = tcp_cksum(ip->ip_src, ip->ip_dst, ip->ip_p,len_tcp,(u_char *)tcp, tcp->th_sum);
    if (chk_sum != tcp->th_sum) {
	//Logger("tcp_sum error\n");
//	ClearTMP();
//	sprintf(tmp,"id = %-10u    off = %-10u   adr= %08x   tcp\n",ntohs(ip->ip_id),ntohs(ip->ip_off),ip->ip_dst.s_addr);
//	Logger(tmp);
//	return 0; ///    
    }
    

    u_long lendata = len_tcp - (tcp->th_off<<2);
    if (lendata == 0) {
//	ClearTMP();
//	sprintf(tmp,"id = %-10u    off = %-10u   adr= %08x   len=0\n",ntohs(ip->ip_id),ntohs(ip->ip_off),ip->ip_dst.s_addr);
//	Logger(tmp);
	return 0;
    }
    
    NTOHS(ip->ip_len);
    if (ip->ip_p == IPPROTO_TCP) parse_TCP(packet);
 return 0;
} 

void
close_kb(void)
{
	tcsetattr(0, TCSANOW, &init_settings);
}



int 
initialize(void){
    V_CURSOR = 1;
    SORTBUFFER = 100;
    FAST_SCREEN = 1;
    frpks = allpks = openfiles = countpks = 0;
    alltraf  = writraf = numpks = speed = 0;
	sortdb = (struct filt *)calloc(SORTBUFFER,sizeof(struct filt));
	if (sortdb == NULL) { printf("malloc sortdb error\n");exit(1);}

    MIN_FILE_SIZE 	= 100000;
    TIME_LIVE_THREAD 	= 60;
    TIME_END_FILE 	= 60;
    TIME_LIVE_BEGIN 	= 3;
    H_LINE 	= 80;
    V_LINE 	= 20;
    NOCOMPLETE 	= 90;
    MAXTHREADS 	= 100;
//    TIME_CHECK = 1;
    strcpy(PATH_LOG,"./log.txt");
    strcpy(PATH_OK,"./ok");
    strcpy(PATH_TEMP,"./temp");    
    strcpy(PATH_INCOMPLETE,"./incomplete");

    int i=0;
    u_char var[100];
    u_int64 value;
    FILE *fd;
    if ( (fd = fopen("./skyfish.conf","r")) == NULL){
        if ( (fd = fopen("/usr/local/etc/skyfish.conf","r")) == NULL){
	    printf("Not found file skyfish.conf\n");
	    return 1;
	}
    }

    while (fscanf(fd,"%s",var)>0)
	{
	if (strstr(var,"MIN_FILE_SIZE")  != NULL) 	fscanf(fd,"%u",&MIN_FILE_SIZE);	
	if (strstr(var,"TIME_LIVE_THREAD")  != NULL) 	fscanf(fd,"%u",&TIME_LIVE_THREAD);
	if (strstr(var,"TIME_LIVE_BEGIN")  != NULL) 	fscanf(fd,"%u",&TIME_LIVE_BEGIN);
	if (strstr(var,"TIME_END_FILE")  != NULL) 	fscanf(fd,"%u",&TIME_END_FILE);
	if (strstr(var,"NOCOMPLETE")  != NULL) 		fscanf(fd,"%u",&NOCOMPLETE);
	if (strstr(var,"V_LINE")  != NULL) 		fscanf(fd,"%u",&V_LINE);
	if (strstr(var,"H_LINE")  != NULL) 		fscanf(fd,"%u",&H_LINE);
	if (strstr(var,"MAXTHREADS")  != NULL) 		fscanf(fd,"%u",&MAXTHREADS);
	if (strstr(var,"OK")  != NULL) 			fscanf(fd,"%s",PATH_OK);	
	if (strstr(var,"TEMP")  != NULL) 		fscanf(fd,"%s",PATH_TEMP);
	if (strstr(var,"INCOMPLETE")  != NULL) 		fscanf(fd,"%s",PATH_INCOMPLETE);
	if (strstr(var,"LOG")  != NULL) 		fscanf(fd,"%s",PATH_LOG);
	if (strstr(var,"type")  != NULL) {
	    for (i=0; i < SORTBUFFER; i++)
		if ( strlen(sortdb[i].type) == 0) {
		    fscanf(fd,"%s",sortdb[i].type);
		    fscanf(fd,"%lu",&sortdb[i].min);
		    fscanf(fd,"%lu",&sortdb[i].max); 		    
		    i = SORTBUFFER;
		}
	    
	}
	memset(var,0,100);
	}
    fclose(fd);
    flog = fopen(PATH_LOG,"w+");
    if (flog == NULL) {Logger("error create log file\n"); return 1;}

return 0;
}


u_short
in_cksum3(const u_short *addr, register u_int len, int csum)
{
	int nleft = len;
	const u_short *w = addr;
	u_short answer;
	int sum =-(csum);
	/*
	 *  Our algorithm is simple, using a 32 bit accumulator (sum),
	 *  we add sequential 16 bit words to it, and at the end, fold
	 *  back all the carry bits from the top 16 bits into the lower
	 *  16 bits.
	 */
	while (nleft > 1)  {
		sum += *w++;
		nleft -= 2;
	}
	if (nleft == 1)
		sum += htons(*(u_char *)w<<8);

	/*
	 * add back carry outs from top 16 bits to low 16 bits
	 */
	sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
	sum += (sum >> 16);			/* add carry */
	answer = ~sum;				/* truncate to 16 bits */
	return answer;
}

/* for computing TCP/UDP checksums, see TCP/IP Illustrated p. 145 */
u_short 
tcp_cksum(const struct in_addr src, const struct in_addr dst,
				  u_char proto, u_short len,const char *hstart, u_short csum)
{
	struct pseudo {
		struct in_addr src;
		struct in_addr dst;        
		u_char zero;
		u_char proto;        
		u_short length;
	};
	struct pseudo hdr;
	hdr.src = src;
	hdr.dst = dst;
	hdr.zero = 0;
	hdr.proto = proto;
	hdr.length = ntohs(len);
	u_short res=0;
	res=in_cksum3((u_short *) &hdr, sizeof(struct pseudo),0);
	res=in_cksum3((u_short *) hstart, len,csum+res);
	return res;
}

void 
CloseProg (void){
    fclose(flog);
    endwin();
    exit(0);
}


u_char*
SborkaIP(u_char packet) {
/*
        (1)  BUFID <- source|destination|protocol|identification;
        (2)  IF FO = 0 AND MF = 0
		      
		       
                             with BUFID;
                             TIMER <- TLB; TDL <- 0;
		  data  FO*8  (TL-(IHL*4))+FO*8;
		  RCVBT  FO  FO+((TL-(IHL*4)+7)/8);
        (10)     MF = 0  TDL <- TL-(IHL*4)+(FO*8)
        (11)     FO = 0   header  
        (12)     TDL != 0
        (13)          &    0  (TDL+7)/8 
			 TL <- TDL+(IHL*4)
			         
                             for this BUFID; DONE.
			       1  
*/
return NULL;
}

void
ChFastScr(void) {

    if (FAST_SCREEN == 0) FAST_SCREEN = 1;
	else FAST_SCREEN = 0;
}

int
CheckPath(void) {
    struct stat dr;
    if (stat(PATH_OK,&dr) != 0) {printf("not found %s\n",PATH_OK);return 1;}
    if (stat(PATH_TEMP,&dr) != 0) {printf("not found %s\n",PATH_TEMP);return 1;}
    if (stat(PATH_INCOMPLETE,&dr) != 0) {printf("not found %s\n",PATH_INCOMPLETE);return 1;}
return 0;
}

